/********************************************************************-*-c-*-*\
*               *  Class examples for Advanced Porgramming                   *
*    #####      *  (!) Giovanni Squillero <giovanni.squillero@polito.it>     *
*   ######      *                                                            *
*   ###   \     *  Copying and distribution of this file, with or without    *
*    ##G  c\    *  modification, are permitted in any medium without royalty *
*    #     _\   *  provided this notice is preserved.                        *
*    |   _/     *  This file is offered as-is, without any warranty.         *
*    |  _/      *                                                            *
*               *  See: http://staff.polito.it/giovanni.squillero/dida.php   *
\****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "utils.h"
#include "hash.h"

static unsigned long int hash2(unsigned long int k)
{
}

static unsigned long int hash(const char *k)
{
	unsigned long int h = 5337lu;
	int t;
	
	for(t=0; k[t]!='\0'; ++k)
		h = ((h << 5) + h) + k[t];
	return h; 
}

HASH *hashCreate(int size)
{
	HASH *H;
	int t;
	
	H = (HASH *)Malloc(sizeof (HASH));
	H->size = size;
	H->table = (ELEM **)Malloc(H->size * sizeof (ELEM *));
	for(t=0; t<H->size; ++t)
		H->table[t] = NULL;
	return H;
}

void hashInsert(HASH *H, char *key, DATA *data)
{
	unsigned long int h;
	ELEM *E;
	
	h = hash(key) % H->size;
	printf("Chiave \"%s\": %lu\n", key, h);
	E = (ELEM *)Malloc(sizeof (ELEM));
	E->key = Strdup(key);
	E->data = *data;
	E->next = H->table[h];
	H->table[h] = E;
}

DATA *hashSearch(HASH *H, char *key)
{
	unsigned long int h;
	ELEM *E;

	h = hash(key) % H->size;
	for(E=H->table[h]; E; E=E->next)
		if(!strcmp(E->key, key))
			return &E->data;
	return NULL;
}


void hashDebug(HASH *H)
{
	ELEM *E;
	int t;
	
	for(t=0; t<H->size; ++t) {
		printf("%d:", t);
		for(E=H->table[t]; E; E=E->next)
			printf(" %p", (void*)E);
		printf("\n");
	}
}

void hashDelete(HASH *H, char *key);

